/*! 
    \file primitive_model.h

*/

#ifndef _PRIMITIVE_MODEL_H
#define _PRIMITIVE_MODEL_H

#include "model.h"

//! Specification of different primitives the Model knows
enum PRIMITIVE {PLANE, CUBE, SPHERE, CYLINDER, CONE};

// FORWARD DEFINITION \\

//! A Class to create some default Models
class PrimitiveModel : public Model {

 public:
  PrimitiveModel();
  PrimitiveModel(PRIMITIVE type, float size = 1.0, unsigned int detail = 10);

  virtual ~PrimitiveModel();

 protected:
  void cubeModel(void);
  void sphereModel(float size = 1.0, unsigned int detail = 10);
  void cylinderModel(float size = 1.0, unsigned int detail = 10);
  void coneModel(float size = 1.0, unsigned int detail = 10);
  void planeModel(float size = 1.0, unsigned int detail = 1);
};

#endif /* _PRIMITIVE_MODEL_H */
